'***************************************
'      BULLETIN SYSTEM FOR NETWORK
'       9/21/91    by Tim Greif
'***************************************

'This program finds and reads any bulletins created with the 
'filename "BULLETIN.#" where the file extensions ".#" are consecutively
'numbered beginning with 1.

'Each bulletin file should comply with the following:
'       1.  Must be a pure ASCII text file.  Upper ASCII graphics
'           and line draw characters are OK.
'       2.  First line of file is the bulletin title which
'           will appear on the main bulletin menu (70 characters max).
'       3.  File width is limited to 80 characters per line.
'       4.  Length of file is unlimited.  Program automatically scrolls
'           23 lines at a time.
'       5.  Don't put any ANSI control codes in the file.

'Up to 9 bulletins are supported.  

'The main menu screen was created to resemble the Netware Syscon menu.  It
'includes a network user field.  The program expects to find an environment
'variable "USER" which it reads and places in that field.  If the USER
'variable is not found, it simply leaves the field blank.

'The main menu automatically sizes the menu box to accommodate the number
'of bulletins and the width of the largest bulletin title.

'If no bulletins are found (or if BULLETIN.1 is missing), the program
'simply aborts itself.


CLS
ON ERROR GOTO HANDLER

'***** SEE WHICH FILES EXIST *****
FOR I = 1 TO 9
	A$ = RIGHT$(STR$(I), 1)
	OPEN "BULLETIN." + A$ FOR INPUT AS #I
	LINE INPUT #I, TITLE$(I)
	NUMB = I
	CLOSE #I
NEXT I

'****** MAIN SCREEN ******
AGAIN:
CLS : COLOR 1, 3
PRINT "Ŀ"
PRINT " NetWare User:                                       [your Company Name here] "
PRINT " on File Server [name of your server]                   [City] Office Network "
PRINT ""
COLOR 15, 3: LOCATE 2, 17: PRINT ENVIRON$("USER")
LOCATE 5, 1: COLOR 3, 1
FOR I = 5 TO 21
	PRINT STRING$(80, 176)
NEXT I
COLOR 15, 1
PRINT CHR$(218); STRING$(78, 196); CHR$(191)
PRINT CHR$(179); SPACE$(78); CHR$(179)
PRINT CHR$(192); STRING$(78, 196); CHR$(217);
LOCATE 23, 3: COLOR 0, 7
PRINT SPACE$(15); "Press Number of Bulletin to Read"; SPACE$(16); CHR$(179); " <ESC>=EXIT "
COLOR 15, 1

'********** PRINT TITLES OF BULLETINS IN MENU BOX *************
'**** AUTOMATICALLY SIZES BOX HORIZONTALLY AND VERTICALLY *****
WIDE = 21
FOR I = 1 TO NUMB
	IF 7 + LEN(TITLE$(I)) > WIDE THEN WIDE = 7 + LEN(TITLE$(I))
NEXT I
HIGH = 4 + NUMB
ROW = 5 + INT((17 - HIGH) / 2)
COL = INT((80 - WIDE - 2) / 2) + 1
COLOR 14, 1
LOCATE ROW, COL: PRINT CHR$(201); STRING$(WIDE, 205); CHR$(187)
LOCATE ROW + 1, COL: PRINT CHR$(186); SPACE$(WIDE); CHR$(186)
LOCATE ROW + 2, COL: PRINT CHR$(199); STRING$(WIDE, 196); CHR$(182)

FOR I = 1 TO NUMB
	LOCATE ROW + 2 + I, COL: PRINT CHR$(186); SPACE$(WIDE); CHR$(186)
NEXT I

LOCATE ROW + 3 + NUMB, COL: PRINT CHR$(200); STRING$(WIDE, 205); CHR$(188)

COLOR 15, 1: LOCATE ROW + 1, COL + INT((WIDE - 19) / 2) + 1
PRINT "AVAILABLE BULLETINS"

FOR K = 1 TO NUMB
LOCATE ROW + 2 + K, COL + 1: PRINT K; " - "; TITLE$(K)
NEXT K

'***** USER SELECTS BULLETIN TO READ *******
PRESS:
Q$ = INPUT$(1)
	IF VAL(Q$) <= NUMB AND VAL(Q$) > 0 THEN
		CLS : OPEN "BULLETIN." + Q$ FOR INPUT AS #2
		GOSUB DISPLAY
	ELSEIF Q$ = CHR$(27) THEN
		CLOSE : COLOR 7, 0: CLS : END
	ELSE
		BEEP: GOTO PRESS
	END IF
GOTO AGAIN

'***** OPEN BULLETIN AND DISPLAY 23 LINES AT A TIME *******
DISPLAY:
FLAG$ = "ON"
CLS
FOR J = 1 TO 23
	LINE INPUT #2, L$: PRINT L$
	IF EOF(2) THEN CLOSE #2: FLAG$ = "OFF": EXIT FOR
NEXT J

IF J = 24 THEN
	COLOR 10, 1: LOCATE 24, 33
	PRINT ".....MORE.....";
	COLOR 15, 1
ELSE
	COLOR 10, 1: LOCATE 24, 30
	PRINT "....END OF FILE....";
END IF

'**** WAIT FOR ANY KEY PRESS ****
WHILE INKEY$ = "": WEND
IF FLAG$ = "ON" THEN GOTO DISPLAY
RETURN

'**** ERROR HANDLER WHEN FILE CAN'T BE FOUND ******
HANDLER:
IF ERR = 53 THEN CLOSE
IF NUMB > 0 THEN RESUME AGAIN
CLS : END
